package top.awinx.stu01.common;

import lombok.Data;

/**
 * 全局统一返回结果
 * code：200成功，400失败
 * message：提示信息
 * data：返回数据
 */
@Data
public class Result<T> {
    private Integer code;
    private String message;
    private T data;

    // 成功返回（无数据）
    public static <T> Result<T> success(String message) {
        Result<T> result = new Result<>();
        result.setCode(200);
        result.setMessage(message);
        return result;
    }

    // 成功返回（带数据）
    public static <T> Result<T> success(String message, T data) {
        Result<T> result = new Result<>();
        result.setCode(200);
        result.setMessage(message);
        result.setData(data);
        return result;
    }

    // 失败返回
    public static <T> Result<T> error(String message) {
        Result<T> result = new Result<>();
        result.setCode(400);
        result.setMessage(message);
        return result;
    }

    // 失败返回
    public static <T> Result<T> error(Integer code, String message) {
        Result<T> result = new Result<>();
        result.setCode(code);
        result.setMessage(message);
        return result;
    }
}
